#include <Application.h>
#include <String.h>

#include <MediaRoster.h>
#include <MediaNode.h>
#include <ParameterWeb.h>

#include <stdio.h>
#include <string.h>

BMediaRoster *gMediaRoster;

int main(void) {
	media_node	outNode;
	status_t	err;

	printf("** Media Test 2 v1.0 **\n\n");
	printf("This application will generate a report  about all controls\n");
	printf("reported by the media add-on being used by your audio card.\n");
	printf("Please send the output to bga@bug-br.org.br and include the\n");
	printf("following information:\n\n");
	printf("- Sound Card Model/Maker/Chipset\n");
	printf("- Driver being used (if not the default that comes with R5)\n");
	printf("- BeOS version (Zeta/BeOS R5/BeOS R5 + MKB1/Dano)\n\n");	 
	printf("This version iterates through the BParameters and shows\n");
	printf("information about each parameter found.\n\n");
	
	BApplication myApp("application/x-vnd.BGA-MediaTest2");
	
	gMediaRoster = BMediaRoster::Roster(&err);
	
	if (!gMediaRoster || err != B_OK) {
		printf("Can't get the Media Roster. Is the Media Server running?\n"); 
	} else {
		if (gMediaRoster->GetAudioOutput(&outNode) == B_OK) {
			BParameterWeb * web;
			if (gMediaRoster->GetParameterWebFor(outNode, &web) == B_OK && web) {
				int32 numParameters = web->CountParameters();
				
				printf("Found the ParameterWeb for the audio output node. %d parameters.\n", numParameters);

				for (int32 i = 0; i < numParameters; i++) {
					printf("----------------------------------------\n");
					printf("Parameter Name  : %s\n", web->ParameterAt(i)->Name());
					printf("Parameter Kind  : %s\n", web->ParameterAt(i)->Kind());
					printf("Parameter Group : %s\n", web->ParameterAt(i)->Group()->Name()); 
					printf("----------------------------------------\n");
				}
			}
		}
	}
}
